
#include "iostream.h"
#include "string.h"

class Pojazdy
{
public:
	virtual void Wyswietl()  = 0;
	virtual void CzytajOpis() = 0;
	virtual void TylkoOsobowe() = 0;
	virtual void TylkoCiezarowe() = 0;
};

class PojazdyKolowe : public Pojazdy
{
	int LiczbaOsi;
	int LiczbaKol;
public:
	virtual void CzytajOpis()
	{
		cout << "Podaj liczbe osi : ";
		cin >> LiczbaOsi;
		cout << "Podaj liczbe kol : ";
		cin >> LiczbaKol;
	}
	virtual void Wyswietl()
	{
		cout << "Liczba osi :  " << LiczbaOsi;
		cout << " , liczba kol : " << LiczbaKol <<  endl;
	}
};

class Silnikowe : public PojazdyKolowe
{
	double MocSilnika;
	char RodzajPaliwa[32];
	char Marka[32]; 
public:
	virtual void CzytajOpis ()
	{
		char Bufor[64];

		cout <<  "Podaj moc silnika : ";
		cin >> MocSilnika;

		cout <<  "Podaj rodzaj paliwa : ";
		cin >> Bufor;
		strncpy(RodzajPaliwa, Bufor, 31);

		cout << "Podaj marke samochodu : ";
		cin >> Bufor;
		strncpy(Marka, Bufor, 31);
		PojazdyKolowe::CzytajOpis();
	}
	virtual void Wyswietl()
	{
		cout << endl << "Jest to pojazd marki " << Marka; 
		cout << endl << "Pojazd wypozazony jest w silnik o mocy ";
		cout << MocSilnika << " KM";
		cout << endl << "Rodzaj paliwa : " << RodzajPaliwa << endl ;
		PojazdyKolowe::Wyswietl();
	}
};

class Samochody : public Silnikowe
{

};

class Osobowe : public Samochody
{
	int LiczbaOsob;
public:
	virtual void CzytajOpis()
	{
		cout << endl << "Podaj dopuszczalna liczbe pasazerow samochodu : ";
		cin >> LiczbaOsob;
		Samochody::CzytajOpis();
	}
	virtual void Wyswietl()
	{
		cout << endl << "Prezentujemy samochod osobowy przeznaczony dla ";
		cout << LiczbaOsob << " osob";
		Silnikowe::Wyswietl();
	}
	virtual void TylkoOsobowe()
	{
		Wyswietl();
	}
	virtual void TylkoCiezarowe()
	{
	}
};

class Ciezarowe : public Samochody
{
	double Ladownosc;
public:
	virtual void CzytajOpis()
	{
		cout << endl << "Podaj dopuszczalna ladownosc samochodu : ";
		cin >> Ladownosc;
		Samochody::CzytajOpis();
	}
	virtual void Wyswietl()
	{
		cout << endl<<  "Prezentujemy samochod ciezarowy o ladownosci ";
		cout << Ladownosc << " ton";
		Silnikowe::Wyswietl();
	}
	virtual void TylkoOsobowe()
	{
	}
	virtual void TylkoCiezarowe()
	{
		Wyswietl();
	}

};
void main()
{
	Pojazdy* Ewiden[100];
	bool Dalej = true;
	int Pol;
	int i, Ile = 0;

	while (Dalej)
	{
		cout << endl << "Lista polecen :";
		cout << endl << "1 - wprowadz nowy samochod osobowy,";
		cout << endl << "2 - wprowadz nowy samochod ciezarowy,";
		cout << endl << "3 - wyprowadz opisy wszystkich samochodow,";
		cout << endl << "4 - wyprowadz opisy samochodow osobowych,";
		cout << endl << "5 - wyprowadz opisy samochodow ciezarowych,";
		cout << endl << "0 - koniec programu.";
		cout << endl << "Wprowadz polecenie : ";
		
		cin >> Pol;
		
		switch(Pol)
		{
		case 0 : cout << endl << "Koniec programu.";
				 Dalej = false;
				 break;
		case 1 : if (Ile < 100)
				 {
					Ewiden[Ile] = new Osobowe();
					Ewiden[Ile++]->CzytajOpis();
				 }
				 else
					 cout << endl << "Tablica pelna.";
				 break;
		case 2 : if (Ile < 100)
				 {
					Ewiden[Ile] = new Ciezarowe();
					Ewiden[Ile++]->CzytajOpis();
				 }
				 else
					 cout << endl << "Tablica pelna.";break;
		case 3 : for (i = 0 ; i < Ile ; i++)
					 Ewiden[i]->Wyswietl();
				 break;
		case 4 : for (i = 0 ; i < Ile ; i++)
					 Ewiden[i]->TylkoOsobowe();
				 break;
		case 5 : for (i = 0 ; i < Ile ; i++)
					 Ewiden[i]->TylkoCiezarowe();
				 break;
		}
	}
	cout << endl;
}

